/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.SistemaDAO;
import com.rjconsultores.ventaboletos.entidad.Sistema;
import com.rjconsultores.ventaboletos.service.SistemaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("sistemaService")
public class SistemaServiceImpl implements SistemaService {

    @Autowired
    private SistemaDAO sistemaDAO;

    public List<Sistema> obtenerTodos() {
        return sistemaDAO.obtenerTodos();
    }

    public Sistema obtenerID(Integer id) {
        return sistemaDAO.obtenerID(id);
    }

    @Transactional
    public Sistema suscribir(Sistema entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return sistemaDAO.suscribir(entidad);
    }

    @Transactional
    public Sistema actualizacion(Sistema entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return sistemaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Sistema entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        sistemaDAO.actualizacion(entidad);
    }
}
